<?php
ini_set('display_errors', true);
session_start();
if (!$_SESSION['admin']) {
    header('Location:index.php');

}


if (isset($_POST['visitedimportexcel'])) {

    //checking imported excel file size
    if ($_FILES['visitedimportexcel']['size'] > 0) {

        //save uploaded excel file
        $targetPath = 'uploads/'.$_FILES['visitedimportexcel']['name'];
        move_uploaded_file($_FILES['visitedimportexcel']['tmp_name'], $targetPath);

        //DB connection
        include_once '../database/db.php';
        $dbcreatevisit = new Database("localhost", "aasfle5_HolcimFatigueUser", "ggUsjQl&Oa.[", "aasfle5_HolcimFatigue");
        //get data from excel file and validate
        $data = getExcelData($targetPath);
        if($data==false){		
        	$_SESSION["errorvisitedimportexcel"] = "'loading_ts', 'shipto_sap_no'  or 'vehicle cells' empty. Please fill!!!";
    		header('Location:visitedimportexcel.php');
    		exit();
        }
        
        //add plate numbber to data from excel file
        $data = addPlateNumberToData($data);


        //Check loading_ts_date ,shipto_sap_no or vehicle already exist or not in db
        //If exist delete old records
        foreach ($data as $dataRow){
        	$where="loading_ts_date='".$dataRow['loading_ts_date']."'";
        	$checkresponse=$dbcreatevisit->deleteMultiple("VisitedExcelImport", $where);
        }


        //insert data to DB
        $responseMessage="";
        foreach ($data as $dataRow){
            //get response of insertion
            $response = $dbcreatevisit->insertWithErrorResponse("VisitedExcelImport", $dataRow);

            //if error then store message
            if(!$response['type']){
                $responseMessage.=$response['message'];
            }
            
            // print_r("<pre>");
            // print_r($responseMessage);
            // print_r("</pre>");
            
        }
        // die();

        //DB disconnect
        $dbcreatevisit->disconnect();

        //redirect to import page
        $_SESSION["errorvisitedimportexcel"] = "Successfully imported";
	    header('Location:visitedimportexcel.php');		
    } else {

        $_SESSION["errorvisitedimportexcel"] = "Please, select file!";
        header('Location:visitedimportexcel.php');
    }
} else {


    $_SESSION["errorvisitedimportexcel"] = "Please, select file!";
    header('Location:visitedimportexcel.php');
}

function addPlateNumberToData($data){

    require '../Classes/regularexpression.php';
    $regularExpression = new RegularExpression();

    //get plate number for each vehicle
    foreach ($data as $key=>$dataRow){
        $data[$key]['plate']=$regularExpression->findPlate($dataRow['vehicle']);
    }
    return $data;
}


function getExcelData($path)
{

    $data = [];

    require '../Classes/PHPExcel.php';
    require_once '../Classes/PHPExcel/IOFactory.php';

    $objPHPExcel = PHPExcel_IOFactory::load($path);
    foreach ($objPHPExcel->getWorksheetIterator() as $worksheet) {
        $worksheetTitle = $worksheet->getTitle();
        $highestRow = $worksheet->getHighestRow(); // e.g. 10
        $highestColumn = $worksheet->getHighestColumn(); // e.g 'F'
        $highestColumnIndex = PHPExcel_Cell::columnIndexFromString($highestColumn);
        $nrColumns = ord($highestColumn) - 64;

        for ($row = 2; $row <= $highestRow; ++$row) {
            //store each row in dataRow
            $dataRow = [];
            for ($col = 0; $col < $highestColumnIndex; ++$col) {
                $cell = $worksheet->getCellByColumnAndRow($col, $row);
                $val = $cell->getFormattedValue();
                $dataRow[] = $val;
            }

            $chehkExcelImportEmptyValidation=excelImportEmptyValidation($dataRow[0],$dataRow[3],$dataRow[7]);
            if($chehkExcelImportEmptyValidation==false){
            	return false;   
            }

            //save dataRow columns into dataColumn
            $dataColumn['loading_ts_date'] = returnDate($dataRow[0]);
            $dataColumn['loading_ts'] = returnDateTime($dataRow[0]);
            $dataColumn['order_number'] = $dataRow[1];
            $dataColumn['lds_delivery_note_no'] = $dataRow[2];
            $dataColumn['shipto_sap_no'] = $dataRow[3];
            $dataColumn['sold_to'] = $dataRow[4];
            $dataColumn['city'] = $dataRow[5];
            $dataColumn['ship_to'] = $dataRow[6];
            $dataColumn['vehicle'] = $dataRow[7];

            $data[] = $dataColumn;
        }
    }
    
    //   print_r("<pre>");
    //         print_r($data);
    //         print_r("</pre>");
    //         die();
            
    return $data;
}


function excelImportEmptyValidation($loading_ts,$shipto_sap_no,$vehicle){
    if(empty($loading_ts) || empty($shipto_sap_no) || empty($vehicle)){
        return false;
    }
    return true;
}


function returnDate($input_date){
    //mm/dd/yy hh:mm:ss 
    if(!empty($input_date)){
        $day = substr($input_date,0,2);
        $month = substr($input_date,3,2);
        $year = '20' . substr($input_date,6,2);
        $time = substr($input_date,8);
        $output_date = $year . "-" . $month . "-" . $day;
        return $output_date;
    }
    return Null;
} 


function returnDateTime($input_date){
    //mm/dd/yy hh:mm:ss 
    if(!empty($input_date)){
        $day = substr($input_date,0,2);
        $month = substr($input_date,3,2);
        $year = '20' . substr($input_date,6,2);
        $time = substr($input_date,8);
        $output_date = $year . "-" . $month . "-" . $day . $time;
        return $output_date;
    }
    return Null;
}   

?>