<?php 

class WialonApi 
{
	 private $token;
	 private  $wialon;
	 private $errorcount = 0;

	 function __construct($token)
	 {
	 	$this->token=$token;
	 }

	 public  function connect()
	 {  
        
        
 	    $wialon_api= new Wialon();
		$result = $wialon_api->login($this->token);
		$json = json_decode($result,true);
	
		if(!isset($json['error']))
		{
			$this->wialon=$wialon_api;
			$this->errorcount = 0;
			return $wialon_api;
		}
		 else {
            $this->errorcount++;
            echo WialonError::error($json['error']);

            // Check if error count has reached 5 and stop if it has
            if ($this->errorcount >= 5) {
                echo "Maximum retry limit reached. Stopping attempts to connect.";
                return null;
            }

            // Recursive call if error occurs and count is less than 5
            sleep(10);
            return $this->connect();
        }
	 }
	 
	public function getSearchData($itemsType,$flags=1,$propName="sys_name",$propValueMask="*",$sortType="list")
	{			
		$wialon_api=$this->connect();
		$param = array(
			"spec"=>array(
				"itemsType"=>$itemsType,
				"propName"=>$propName,
				"propValueMask"=>$propValueMask,
				"sortType"=>$sortType,						
				),
		       'force' =>1,
				'from' =>0,
				'to'=>0,
				'flags' =>$flags
		);
		 $response =  $wialon_api->core_search_items(json_encode($param));
		 $response_json = json_decode($response,true);
		 $wialon_api->logout();
		 return $response_json;	 
	}

	public function getSearchDataById($itemsId,$flags)
	{			
		$wialon_api=$this->connect();
		$param = array(
				'id'=>$itemsId,
				'flags' =>$flags
		);
		 $response =  $wialon_api->core_search_item(json_encode($param));
		 $response_json = json_decode($response,true);
		 $wialon_api->logout();
		 return $response_json;	 
	}


//Used tripSheet
	public function allUnitsWithMilliageProfil($flags =8396801)
	{
		$propName="sys_name";
		$result=$this->getSearchData("avl_unit",$flags,$propName);
		$units=array();
		$i=0;
		foreach ($result["items"] as $key => $items) 
		{
				$units[$i]["nm"]=$items["nm"];
				$units[$i]["milliage"]=$items["cnm"];
				$units[$i]["id"]=$items["id"];
				foreach ($items["pflds"] as $key => $val)
				{
					$units[$i][$val["n"]]=$val["v"];
				}
				
				$i++;
		}
		// print_r("<pre>");
		// print_r($units);
		// print_r("</pre>");
		// die();
		return $units;	  
	}


	//Used in service table
	function getAllResource()
     {
        $result_resources=$this->getSearchData("avl_resource",1,"sys_name","*","sys_id");
        $i=0;
        foreach ($result_resources["items"] as $key => $value) 
        {
                $resource[$i]["id"]=$value["id"];
                $resource[$i]["nm"]=$value["nm"];
                $i++;
        }

        return $resource;
     }


	public function drivers($flags=256)
	{
		$propName="drivers";
		$result=$this->getSearchData("avl_resource",$flags,$propName,"*","sys_id");
		$drivers=array();
		$i=0;
		foreach ($result["items"] as $key => $items) 
		{
			if(!empty($items)){
				foreach ($items["drvrs"] as $key => $value) 
				{ 
					$drivers[$i]["id"]=$value["id"];
					$drivers[$i]["n"]=$value["n"];
					$drivers[$i]["c"]=$value["c"];
					$i++;
				}
			}
		}
		return $drivers;
	}


	//Find selected driver in alldrivers
	function getSelectedDriver($drivercode)
     {
	   $drivers=$this->drivers();
       foreach ($drivers as $driver) {

			//Bu siyahıdakı açarın kodu 16 və 10-luq say sistemində ola bilər.Əgər 16-sa 10-a çeviriək(16-lıq olması əvvəlində sıfır olması ilə təyin olunur),deyilsə elə 10-luq qalır.
			$drvcode;
			if(substr($driver['c'], 0, 1)==0){
				$drvcode=hexdec($driver['c']);
			}
			else{
				$drvcode=$driver['c'];
			}

			if($drvcode==$drivercode){	

				return $driver;
			}
		}

			return null;
     }



	public function reports($flags=8192)	
	{	
		$propName="reporttemplates";		
		$result=$this->getSearchData("avl_resource",$flags,$propName);
		$reports=array();
		$i=0;
		foreach ($result["items"] as $key => $items) 
		{
			foreach ($items["rep"] as $key => $value) 
			{ 
				$reports[$i]["id"]=$value["id"];
				$reports[$i]["n"]=$value["n"];
				$reports[$i]["ct"]=$value["ct"];
				$reports[$i]["c"]=$value["c"];
				$i++;
			}
		}
		return $reports;

	}
 		

	public function unitOfResource($flags =16384)
	{
		$propName="sys_name";
		$result_units=$this->getSearchData("avl_resource",$flags,$propName);
		print_r("<pre>");
		print_r($result_units);
		print_r("</pre>");
			return $result_units;	  
	}

	public function allUnits($flags =1)
	{
		$propName="sys_name";
		$result=$this->getSearchData("avl_unit",$flags,$propName);
		$units=array();
		$i=0;
		foreach ($result["items"] as $key => $items) 
		{
				$units[$i]["id"]=$items["id"];
				$units[$i]["nm"]=$items["nm"];
				$units[$i]["uacl"]=$items["uacl"];
				$units[$i]["cls"]=$items["cls"];
				$i++;
		}
		return $units;	  
	}

	public function allUnitsWithRealDeviceIdAndVehicleType($flags =8388865)
	{
		$propName="sys_name";
		$result=$this->getSearchData("avl_unit",$flags,$propName);
		$units=array();
		$i=0;
		foreach ($result["items"] as $key => $items) 
		{
				$units[$i]["id"]=$items["id"];
				$units[$i]["nm"]=$items["nm"];
				$units[$i]["device_id"]=$items["uid"];

				if(!empty($items["pflds"])){
					$hasvehicletype=false;
					foreach ($items["pflds"] as $key => $value) {
						if($value["n"]=="vehicle_type"){
							$units[$i]["vehicle_type"]="truck";
							$hasvehicletype=true;
							break;
						}
					}
					if($hasvehicletype==false){
						$units[$i]["vehicle_type"]="light";
					}
				}
				else{
					$units[$i]["vehicle_type"]="light";
				}

				$i++;
		}
		return $units;	  
	}


//Used YolVereqesi
	public function driversWithField($flags=256)
	{
		$propName="drivers";
		$result=$this->getSearchData("avl_resource",$flags,$propName);
		// print_r("<pre>");
		// print_r($result);
		// print_r("</pre>");
		// die();
		$drivers=array();
		$i=0;
		foreach ($result["items"] as $key => $items) 
		{
			if (isset($items["drvrs"])){
				foreach ($items["drvrs"] as $key => $value) 
				{ 
					$drivers[$i]["n"]=$value["n"];
					$drivers[$i]["limit"]=$value["ds"];
						$jp=$value["jp"];
					if (isset(array_keys($jp)[0])) {
						$cg=array_keys($jp)[0];
						$drivers[$i]["cg"]=$cg;
						$drivers[$i]["cg_id"]=$jp[$cg];
					}else{
						$drivers[$i]["cg"]="-";
						$drivers[$i]["cg_id"]="-";
					}
					
					$i++;
				}
			}
			
		}
		return $drivers;
	}


//Used in service table
	public function allDataOfUnits($flags =261)
	{
		$propName="sys_name";
		$result=$this->getSearchData("avl_unit",$flags,$propName);
		$units=array();
		$i=0;
		foreach ($result["items"] as $key => $items) 
		{
			$units[$i]["id"]=$items["id"];
			$units[$i]["nm"]=$items["nm"];
			$units[$i]["uid"]=$items["uid"];
			$units[$i]["ph"]=$items["ph"];
			$units[$i]["bact"]=$items["bact"];
			$i++;
		}
		return $units;	  
	}
	

	public function unit_group($flags =1)
	{
		$propName="sys_name";
		$result=$this->getSearchData("avl_unit_group",$flags,$propName);
		$units_group=array();
		$i=0;
		foreach ($result["items"] as $key => $items) 
		{
				$units_group[$i]["id"]=$items["id"];
				$units_group[$i]["nm"]=$items["nm"];
				for ($j=0; $j < count($items['u']); $j++) 
				{ 
				  $units_group[$i]["u"][$j]=$items["u"][$j];
				}
				$i++;
		}
		// print_r("<pre>");
		// print_r($units_group);
		// print_r("</pre>");
		return $units_group;	  
	}

	public function unitinfo_by_id($itemsId){
		$flags=257;
		$result=$this->getSearchDataById($itemsId,$flags);
		return $result;
	}

	public function unit_groupby_id($itemsId)
	{
		$flags=1;
		$result=$this->getSearchDataById($itemsId,$flags);
		// $units_group=array();
		// $i=0;
		// foreach ($result["items"] as $key => $items) 
		// {
		// 		$units_group[$i]["id"]=$items["id"];
		// 		$units_group[$i]["nm"]=$items["nm"];
		// 		for ($j=0; $j < count($items['u']); $j++) 
		// 		{ 
		// 		  $units_group[$i]["u"][$j]=$items["u"][$j];
		// 		}
		// 		$i++;
		// }
		// print_r("<pre>");
		// print_r($units_group);
		// print_r("</pre>");
		return $result['item'];	  
	}


   public function geofences($flags=4096)
    {
        $respons=array();
        $propName="sys_id";
        $result=$this->getSearchData("avl_resource",$flags,$propName,14147503,"sys_name");
        $i=0;
        foreach ($result["items"][0]["zl"] as $key => $items)
        {
            $respons[$i]["id"]=$items["id"];
            $respons[$i]["name"]=$items["n"];
            $respons[$i]["description"]=$items["d"];
            $respons[$i]["longitude"]=$items["b"]["cen_x"];
            $respons[$i]["latitude"]=$items["b"]["cen_y"];
            $i++;
        }
        return $respons;
    }


  // Get report
  function getExecReport($unit_id,$timeFrom="",$timeTo="")
  {

  	$result=array();
    // echo "unit_id=".$unit_id."<br>";
    date_default_timezone_set('Asia/Baku');
    $timeFrom = strtotime($timeFrom);
    $timeTo = strtotime($timeTo);
    $timeBegin = time();
    $param = array(
                "reportResourceId"=>14147503,  //$resource_id manager02=13708108,  //  $resource_id bp=14229574
                "reportTemplateId"=>16, // 92 for manag2r02 // 110=for bp
                "reportObjectId"=>$unit_id, //$unit_id, //15801178,   //$object_id,        //$object_id,
                "reportObjectSecId"=>0,
                "interval"=>array( 
                "from"=>$timeFrom, //0,
                "to"=>$timeTo, //1,      
                "flags"=>0x00
               )        
            );
    
    $wialon=$_SESSION['wialon']->connect();

    //  for local time format
    $locale_set_params = array(
                      'tzOffset'=>134232128,
                      'language'=>'EN',
                      'flags'=>256,
                      'formatDate'=>'%25E.%25m.%25Y%25H:%25M:%25S'
                      );
    $locale_set_response = $wialon->render_set_locale(json_encode($locale_set_params));

             $attempts = 0; 
             $response =  $wialon->report_exec_report(json_encode($param));

             $response_json = json_decode($response,true);

             //Find name of tables in report
             $reporttablename=array();
             foreach ($response_json['reportResult']['tables'] as $detail) {
             	array_push($reporttablename, $detail['label']);
             }

             $numberOfTables = count($response_json['reportResult']['tables']);
             // echo "reponse=".$response."<br>";
            if ($numberOfTables>=1) 
            {
                // $reportwithdetails=array();
                $report=array();
                for ($k=0;$k<$numberOfTables;$k++)
                {
                    $report_param = array(
                        'tableIndex'=>$k,
                        'config'=>array(
                              'type'=>'range',
                              'data'=>array(
                                  'from'=>0,
                                  'to'=>76000,
                                  'level'=>1
                              )
                            )
                     ); 
                    ini_set('memory_limit', '-1');
                    $table[$k] = $wialon->report_select_result_rows(json_encode($report_param));
                    $table_json[$k] = json_decode($table[$k],true);
                    
                    array_push($report, $table_json[$k]);
                     
                }
                 $wialon->logout();

                 //Add tables name and report into array
                 array_push($result, $reporttablename);
                 array_push($result, $report);
                return  $result;
            } 
               
             $timeEnd = time();
             $execTime = $timeEnd - $timeBegin;
        ob_flush();
        flush();
   }



   public function updateReport($resourceId=14147503,$reportId=11,$gezones)
    {
        date_default_timezone_set('Asia/Baku');
        $wialon_api=$this->connect();
 
        // "p"=>"{\"geozones\":\"gz14147503_1:1502108777,gz14147503_364:1502108778,\"}",
        //  "p"=>"{\"duration\":{\"min\":301,\"flags\":1},\"geozones_ex\":{\"zones\":\"1,364\",\"types\":\"0,0\",\"flags\":0}}",
        $geoForVisit="{\"grouping\":\"{\\\"type\\\":\\\"geozone\\\"}\",\"geozones\":\"";
        $geoForIdleAndCompressor="\"geozones_ex\":{\"zones\":\"";
        foreach ($gezones as $geo) {
        	$geoForVisit.="gz".$resourceId."_".$geo['id'].",";
        	$geoForIdleAndCompressor.=$geo['id'].",";
        }
        $geoForVisit.="\"}";
        $geoForIdleAndCompressor.="\",\"types\":\"0,0\",\"flags\":0}";

        $param = array(
		   "id"=>$reportId,
		   "ct"=>"avl_unit_group",
		   "n"=>"HOLCIM_VISIT",
		   "p"=>"{\"descr\":\"\",\"bind\":{\"avl_unit_group\":[]}}",
		   "tbl"=>[
		      [
		         "n"=>"unit_group_stats",
		         "l"=>"Статистика",
		         "f"=>0,
		         "c"=>"",
		         "cl"=>"",
		         "cp"=>"",
		         "p"=>"{\"address_format\":\"350552064_10_5\",\"time_format\":\"%Y-%m-%E_%H:%M:%S\",\"us_units\":0}",
		         "sch"=>[
		            "y"=>0,
		            "m"=>0,
		            "w"=>0,
		            "f1"=>0,
		            "f2"=>0,
		            "t1"=>0,
		            "t2"=>0,
		            "fl"=>0
		         ],
		         "sl"=>"[\"Address\",\"Time Format\",\"Measure\",\"Пропускать пустые строки\"]",
		         "s"=>"[\"address_format\",\"time_format\",\"us_units\"]"
		      ],
		      [
		         "n"=>"unit_group_zones_visit",
		         "l"=>"Visited",
		         "f"=>256,
		         "c"=>"[\"zone_name\",\"zone_descr\",\"time_begin\",\"time_end\"]",
		         "cl"=>"[\"Геозона\",\"Описание\",\"Время входа\",\"Время выхода\"]",
		         "cp"=>"[{},{},{}]",
		         "p"=>$geoForVisit,
		         "sch"=>[
		            "y"=>0,
		            "m"=>0,
		            "w"=>0,
		            "f1"=>0,
		            "f2"=>0,
		            "t1"=>0,
		            "t2"=>0,
		            "fl"=>0
		         ],
		         "sl"=>"",
		         "s"=>""
		      ],
		      [
		         "n"=>"unit_group_stays",
		         "l"=>"Idle",
		         "f"=>256,
		         "c"=>"[\"time_begin\",\"time_end\",\"duration\",\"location\"]",
		         "cl"=>"[\"Начало\",\"Конец\",\"Длительность\",\"Положение\"]",
		         "cp"=>"[{},{},{},{}]",
		         "p"=>"{\"duration\":{\"min\":301,\"flags\":1},".$geoForIdleAndCompressor."}",
		         "sch"=>[
		            "f1"=>0,
		            "f2"=>0,
		            "t1"=>0,
		            "t2"=>0,
		            "m"=>0,
		            "y"=>0,
		            "w"=>0,
		            "fl"=>0
		         ],
		         "sl"=>"",
		         "s"=>""
		      ],
		      [
		         "n"=>"unit_group_digital_sensors",
		         "l"=>"Compressor",
		         "f"=>256,
		         "c"=>"[\"sensor_name\",\"time_begin\",\"time_end\",\"duration\",\"location\"]",
		         "cl"=>"[\"Датчик\",\"Вкл.\",\"Откл.\",\"Длительность\",\"Положение\"]",
		         "cp"=>"[{},{},{},{}]",
		         "p"=>"{\"sensor_name\":\"Compressor,Компрессор\",".$geoForIdleAndCompressor."}",
		         "sch"=>[
		            "f1"=>0,
		            "f2"=>0,
		            "t1"=>0,
		            "t2"=>0,
		            "m"=>0,
		            "y"=>0,
		            "w"=>0,
		            "fl"=>0
		         ],
		         "sl"=>"",
		         "s"=>""
		      ]
		   ],
		   "t"=>"avl_unit",
		   "itemId"=>$resourceId,
		   "callMode"=>"update"
        );

        $response=$wialon_api->report_update_report(json_encode($param));
        $response_json = json_decode($response,true);
        $wialon_api->logout();
        return $response_json;
    }
    
    public function createReport($resourceId=14147503,$gezones)
    {
        date_default_timezone_set('Asia/Baku');
        $wialon_api=$this->connect();
 
        // "p"=>"{\"geozones\":\"gz14147503_1:1502108777,gz14147503_364:1502108778,\"}",
        //  "p"=>"{\"duration\":{\"min\":301,\"flags\":1},\"geozones_ex\":{\"zones\":\"1,364\",\"types\":\"0,0\",\"flags\":0}}",
        $geoForVisit="{\"grouping\":\"{\\\"type\\\":\\\"geozone\\\"}\",\"geozones\":\"";
        $geoForIdleAndCompressor="\"geozones_ex\":{\"zones\":\"";
        foreach ($gezones as $geo) {
        	$geoForVisit.="gz".$resourceId."_".$geo['id'].",";
        	$geoForIdleAndCompressor.=$geo['id'].",";
        }
        $geoForVisit.="\"}";
        $geoForIdleAndCompressor.="\",\"types\":\"0,0\",\"flags\":0}";

        $param = array(
           "id"=>0,
		   "ct"=>"avl_unit_group",
		   "n"=>"HOLCIM_VISIT API",
		   "p"=>"{\"descr\":\"\",\"bind\":{\"avl_unit_group\":[]}}",
		   "tbl"=>[
		      [
		         "n"=>"unit_group_stats",
		         "l"=>"Статистика",
		         "f"=>0,
		         "c"=>"",
		         "cl"=>"",
		         "cp"=>"",
		         "p"=>"{\"address_format\":\"350552064_10_5\",\"time_format\":\"%Y-%m-%E_%H:%M:%S\",\"us_units\":0}",
		         "sch"=>[
		            "y"=>0,
		            "m"=>0,
		            "w"=>0,
		            "f1"=>0,
		            "f2"=>0,
		            "t1"=>0,
		            "t2"=>0,
		            "fl"=>0
		         ],
		         "sl"=>"[\"Address\",\"Time Format\",\"Measure\",\"Пропускать пустые строки\"]",
		         "s"=>"[\"address_format\",\"time_format\",\"us_units\"]"
		      ],
		      [
		         "n"=>"unit_group_zones_visit",
		         "l"=>"Visited",
		         "f"=>256,
		         "c"=>"[\"zone_name\",\"zone_descr\",\"time_begin\",\"time_end\"]",
		         "cl"=>"[\"Геозона\",\"Описание\",\"Время входа\",\"Время выхода\"]",
		         "cp"=>"[{},{},{}]",
		         "p"=>$geoForVisit,
		         "sch"=>[
		            "y"=>0,
		            "m"=>0,
		            "w"=>0,
		            "f1"=>0,
		            "f2"=>0,
		            "t1"=>0,
		            "t2"=>0,
		            "fl"=>0
		         ],
		         "sl"=>"",
		         "s"=>""
		      ],
		      [
		         "n"=>"unit_group_stays",
		         "l"=>"Idle",
		         "f"=>256,
		         "c"=>"[\"time_begin\",\"time_end\",\"duration\",\"location\"]",
		         "cl"=>"[\"Начало\",\"Конец\",\"Длительность\",\"Положение\"]",
		         "cp"=>"[{},{},{},{}]",
		         "p"=>"{\"duration\":{\"min\":301,\"flags\":1},".$geoForIdleAndCompressor."}",
		         "sch"=>[
		            "f1"=>0,
		            "f2"=>0,
		            "t1"=>0,
		            "t2"=>0,
		            "m"=>0,
		            "y"=>0,
		            "w"=>0,
		            "fl"=>0
		         ],
		         "sl"=>"",
		         "s"=>""
		      ],
		      [
		         "n"=>"unit_group_digital_sensors",
		         "l"=>"Compressor",
		         "f"=>256,
		         "c"=>"[\"sensor_name\",\"time_begin\",\"time_end\",\"duration\",\"location\"]",
		         "cl"=>"[\"Датчик\",\"Вкл.\",\"Откл.\",\"Длительность\",\"Положение\"]",
		         "cp"=>"[{},{},{},{}]",
		         "p"=>"{\"sensor_name\":\"Compressor,Компрессор\",".$geoForIdleAndCompressor."}",
		         "sch"=>[
		            "f1"=>0,
		            "f2"=>0,
		            "t1"=>0,
		            "t2"=>0,
		            "m"=>0,
		            "y"=>0,
		            "w"=>0,
		            "fl"=>0
		         ],
		         "sl"=>"",
		         "s"=>""
		      ]
		   ],
		   "t"=>"avl_unit",
		   "itemId"=>$resourceId,
		   "callMode"=>"create"
        );

        $response=$wialon_api->report_update_report(json_encode($param));
        $response_json = json_decode($response,true);
        $wialon_api->logout();
        return $response_json;
    }


    public function deleteReport($resourceId=14147503,$reportId)
    {
        date_default_timezone_set('Asia/Baku');
        $wialon_api=$this->connect();

        $param = array(
		   "itemId"=>$resourceId,
		   "id"=>$reportId,
		   "callMode"=>"delete"
        );

        $response=$wialon_api->report_update_report(json_encode($param));
        $response_json = json_decode($response,true);
        $wialon_api->logout();
        return $response_json;
    }
    
    

    function getExecGeozonesReport($unit_id,$timeFrom="",$timeTo="",$reportId=11)
  	{

  	$result=array();
    // echo "unit_id=".$unit_id."<br>";
    date_default_timezone_set('Asia/Baku');
    $timeFrom = strtotime($timeFrom);
    $timeTo = strtotime($timeTo);
    $timeBegin = time();
    $param = array(
                "reportResourceId"=>14147503,  
                "reportTemplateId"=>$reportId,
                "reportObjectId"=>$unit_id,
                "reportObjectSecId"=>0,
                "interval"=>array( 
                "from"=>$timeFrom, //0,
                "to"=>$timeTo, //1,      
                "flags"=>0x00
               )        
            );
    
    $wialon=$_SESSION['wialon']->connect();

    //  for local time format
    $locale_set_params = array(
                      'tzOffset'=>134232128,
                      'language'=>'EN',
                      'flags'=>256,
                      'formatDate'=>'%25E.%25m.%25Y%25H:%25M:%25S'
                      );
    $locale_set_response = $wialon->render_set_locale(json_encode($locale_set_params));

             $attempts = 0; 
             $this->cleanUpResult($wialon);
             $response =  $wialon->report_exec_report(json_encode($param));

             $response_json = json_decode($response,true);

             //Find name of tables in report
             $reporttablename=array();
             foreach ($response_json['reportResult']['tables'] as $detail) {
             	array_push($reporttablename, $detail['label']);
             }

             $numberOfTables = count($response_json['reportResult']['tables']);
             // echo "reponse=".$response."<br>";
            if ($numberOfTables>=1) 
            {
                // $reportwithdetails=array();
                $report=array();
                for ($k=0;$k<$numberOfTables;$k++)
                {
                    $report_param = array(
                        'tableIndex'=>$k,
                        'config'=>array(
                              'type'=>'range',
                              'data'=>array(
                                  'from'=>0,
                                  'to'=>76000,
                                  'level'=>1
                              )
                            )
                     ); 
                    $table[$k] = $wialon->report_select_result_rows(json_encode($report_param));
                    $table_json[$k] = json_decode($table[$k],true);
                    
                    array_push($report, $table_json[$k]);
                     
                }
                 $wialon->logout();

                 //Add tables name and report into array
                 array_push($result, $reporttablename);
                 array_push($result, $report);
                return  $result;
            } 
               
             $timeEnd = time();
             $execTime = $timeEnd - $timeBegin;
        ob_flush();
        flush();
   }
   
   
   
    public function getReportInfo($resourceId=14147503,$reportId=11)
    {
        date_default_timezone_set('Asia/Baku');
        $wialon_api=$this->connect();
 

        $param = array(
		   "itemId"=>$resourceId,
		   "col"=>[$reportId],
		   "flags"=>4
        );

        $response=$wialon_api->report_get_report_data(json_encode($param));
        $response_json = json_decode($response,true);
        $wialon_api->logout();
        return $response_json;
    }
    
    
    public function cleanUpResult($wialon){
        $param=array();
        $response =  $wialon->report_cleanup_result(json_encode($param));
        $response_json = json_decode($response,true);
        print_r("REPORT CLEARED BRGIN");
	    print_r($response_json); 
	    print_r("REPORT CLEARED END");
        return $response_json;
    }
}

  
 ?>