<?php

Class DatabasePG {

    private $host;
    private $port;
    private $username;
    private $password;
    private $dbname;
    private $conn;
    private $result=[];

    public function __construct($hostPr, $port, $dbnamePr, $usernamePr, $passwordPr) {
        $this->host = $hostPr;
        $this->port = $port;
        $this->dbname = $dbnamePr;
        $this->username = $usernamePr;
        $this->password = $passwordPr;
        $this->connect();
    }

    public function connect() {
        $connectionstring="host=".$this->host." port=".$this->port." dbname=".$this->dbname." user=".$this->username." password=".$this->password;
        $this->conn = pg_connect($connectionstring);
        if (!$this->conn) { 
            die('Can"t connect Database');
        }
        // $this->conn->set_charset('utf8');
    }

    public function disconnect() {
        pg_close($this->conn);
    }

    public function select($tableName, $where = Null, $orderby = Null, $limit = Null, $offset = 0,$fields = '*') {
        $this->connect();
        $sql = "SELECT $fields FROM $tableName";
        if ($where == !NULL) {
            $sql .= " WHERE $where";

        }

        if ($orderby == !NULL) {
            $sql .= " ORDER BY $orderby";
        }

        if ($limit == !NULL) {
            $sql .= " LIMIT $limit";
        }

        if ($offset != 0) {
            $sql .= " OFFSET $offset";
        }

        $send = pg_query($this->conn, $sql);
        if(pg_num_rows($send)==0){
            $this->result = pg_fetch_assoc($send);
            pg_free_result($send);
            $this->disconnect();
            return $this->result;
        }
        elseif(pg_num_rows($send)>0){
            ini_set('memory_limit', '-1');
            while ($row = pg_fetch_assoc($send)) {
                    array_push($this->result, $row);
                }
            pg_free_result($send);
            $this->disconnect();
            return $this->result;    
        }
        else{
            $this->disconnect();
            return $this->result = Null;
        }
    }


    public function update($tableName, $data, $condition) {
        $this->connect();
        $sql = "UPDATE $tableName SET";

        $i = 1;
        foreach ($data as $key => $value)
        {
            if ($i == count($data)) {
                $sql .= " $key = '$value' ";

            } else {
                $sql .= " $key = '$value' , ";
            }

            $i++;
        }

        $sql .= " WHERE id=$condition";

        $send = pg_query($this->conn, $sql);
        $result = $send;
        $this->disconnect();
        if ($result) {
            return TRUE;
        } else {
            return FALSE;
        }
    }

    public function delete($tableName, $where) {
        $this->connect();
        $sql = "DELETE FROM $tableName WHERE ID =$where";
        $send = pg_query($this->conn, $sql);
        $result = $send;
        $this->disconnect();
        if ($result) {
            return TRUE;
        } else {
            return false;
        }
    }


    public function insert($tableName, $data) {
        $this->connect();
        $sql = "INSERT INTO $tableName ";
        $sql .="(";
        $keys = array_keys($data);
        foreach ($keys as $key => $value) {
            if ($key == count($keys) - 1) {
                $sql .= $value;
            } else {
                $sql .= $value . ',';
            }
        }
        $values = array_values($data);
        $sql .=") VALUES (";

        foreach ($values as $key => $value) {
            if ($key == count($values) - 1) {
                $sql .= " '$value' ";
            } else {
                $sql .= " '$value' ,";
            }
        }

        $sql .=")";
        $send = pg_query($this->conn, $sql);
        $result = $send;
        $this->disconnect();
        if ($result) {
            return TRUE;
        } else {
            return FALSE;
        }
    }
}
?>